Subject: Re: [PATCH] ARM: OMAP: AM33XX: CAN: d_can: Add support for Bosch D_CAN controller

From: Marc Kleine-Budde <[email-masked]>
Date: Tue, 03 Apr 2012 14:49:48 +0200

On 04/03/2012 02:44 PM, Wolfgang Grandegger wrote:
> On 04/03/2012 02:32 PM, AnilKumar Ch wrote:
>> This patch adds the support for Bosch D_CAN controller.
>>
>> Bosch D_CAN controller is a full-CAN implementation compliant to
>> CAN protocol version 2.0 part A and B. Bosch D_CAN user manual
>> can be obtained from: http://www.semiconductors.bosch.de/media/
>> en/pdf/ipmodules_1/can/d_can_users_manual_111.pdf
>>
>> D_CAN device is used on many SoCs like AM335x, DM8148 and DM813x
>> EVMs from TI, D_CAN details on AM335x can be accessed from:
>> http://www.ti.com/lit/ug/spruh73c/spruh73c.pdf
>>
>> D_CAN can be configurable for 16, 32, 64 and 128 message objects.
>> The driver implementation is based on 64 message objects.
>>
>> Following are the design choices made while writing the controller
>> driver:
>> 1. Interface Register set IF0 has be used for receive and IF1 is
>>    used for transmit message objects.
>> 2. Out of the total Message objects available, half of it are kept
>>    aside for RX purposes and the rest for TX purposes.
>> 3. NAPI implementation is such that both the TX and RX paths
>>    functions in polling mode.
>>
>> Signed-off-by: AnilKumar Ch <[email-masked]>
> 
> Please explain why this CAN controller cannot be handled by the existing
> C_CAN driver, eventually with some extensions. The register layout seems
> almost identical, at least.

ACK.

Have a look at the recent at91_can driver. It has been improved to work
with a flexible number of message objects.

Marc

-- 
Pengutronix e.K.                  | Marc Kleine-Budde           |
Industrial Linux Solutions        | Phone: +49-231-2826-924     |
Vertretung West/Dortmund          | Fax:   +49-5121-206917-5555 |
Amtsgericht Hildesheim, HRA 2686  | http://www.pengutronix.de   |